/*
	CoreHTTP - Embeddable Single-process TCP/IP HTTP Server
	Copyright (C) 2005-2007  Frank Yaul

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

	File: common.h
*/

#ifndef COMMON_H
#define COMMON_H

/*
	all constant global variables defined and set here
	VERSION - self explanatory
	BUFSIZE - larger than an http request, at least 3x larger than PATHSIZE
	PATHSIZE - larger than a URL
	*_S - the string version

	SETSIZE - the size of the array of an option in the config file. we can
		  read this many ports from a config file, this many cgibins,
		  etc. see corehttp.c main()
*/
#define VERSION		"corehttp-0.5.3.1"
#define BUFSIZE		2048
#define BUFSIZE_S	"2048"
#define PATHSIZE	256
#define PATHSIZE_S	"256"
#define	SETSIZE		16

#ifndef GLOBALS_DEFINED

/*
	all changeable global variables defined here
*/
extern int TIMEOUT, PORT[SETSIZE], BACKLOG;
extern char *ROOTDIR, **DEFPAGE, *PAGE404, *LOGFILE, *DIRLIST,
       **CGIEXT, **CGIBIN, **CONTENTEXT, **CONTENTTYPE, *UNKNOWNTYPE;
#include "sprock.h"
extern struct sprock_t *FIRSTSPROCK;

#endif

/*
	initializer
*/
void InitGlobals(int num, char **args);

#endif
