/*
	CoreHTTP - Embeddable Single-process TCP/IP HTTP Server
	Copyright (C) 2005-2007  Frank Yaul

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

	File: handler.h
*/

#ifndef HANDLER_H
#define HANDLER_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <sys/wait.h>
#include "common.h"
#include "sprock.h"

/*
	logfile things and signal handlers. all logging is blocking
*/
FILE *logfile;
void HandleChildProcs(int signum);
void HandleExit(int signum);
void HandleError(char *errstr);
void HandleProblem(char *errstr);
void HandleLog(char *str);
int HandlerInit(void);

#endif
