/*
	CoreHTTP - Embeddable Single-process TCP/IP HTTP Server
	Copyright (C) 2005-2007  Frank Yaul

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

	File: watch.h
*/

#ifndef WATCH_H
#define WATCH_H

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/select.h>
#include "common.h"
#include "sprock.h"

/*
	watch structures, functions
	the structure gets passed around and modified by the watch functions
*/
struct watch_t {
	fd_set read, write, bread, bwrite;
	int highfd;
};

int SetNonBlock(int fd);
struct watch_t *WatchMake(void);
void DeleteWatch(struct watch_t *watch);
int UpdateWatch(struct watch_t *watch, int blockflag);
void AddReadWatch(struct sprock_t *sprocket, struct watch_t *watch);
void AddWriteWatch(struct sprock_t *sprocket, struct watch_t *watch);
void RemoveWatch(struct sprock_t *sprocket, struct watch_t *watch);
int ReadableWatch(struct sprock_t *sprocket, struct watch_t *watch);
int WriteableWatch(struct sprock_t *sprocket, struct watch_t *watch);

#endif
